;=======================================================================================
;Programa paruose Vardarnis Pavardenis
;VU MIF Informatika, N kursas, M gr.
;------------------------------------------------------------------------
;Programa 'mano.asm'. Uzduotis nr. 4
;Nuskaito eilute, mazasias raides pakeicia didziosiomis, o didziasias mazosomis.
;I ekrana isveda eilutes ilgi, didziuju ir mazuju raidziu skaiciu
;=======================================================================================
.model small

.stack 256

UpperA EQU 41h
UpperZ EQU 5Ah
LowerA EQU 61h
LowerZ EQU 7Ah

;=======================================================================================
.data

	inputmax DB  255		    ;kiek maksimaliai simboliu galima nuskaityti
	quantity DB  ?				;cia bus patalpinta, kiek simboliu nuskaityta
	input	 DB  255 dup (?)	;cia bus talpinami nuskaityti simboliai

    putin	 DB "Iveskite simboliu eilute: $"
	putout	 DB "Nauja eilute: $"
	empty    DB "Ivesta eilute tuscia. $"
	stlength DB "Ivestos eilutes ilgis: $"
	gotupper DB "Gauta didziuju/buvo mazuju raidziu: $"
	gotlower DB "Gauta mazuju/buvo didziuju raidziu: $"
    nextline DB 10, 13, "$"

;=======================================================================================
.code
Strt:
    ;------------------------------------------------------------------------
	;Programos darbo pradzia
	;------------------------------------------------------------------------
   	MOV	ax, @data
	MOV	ds, ax
	
	;------------------------------------------------------------------------
	;Ivedami duomenis
	;------------------------------------------------------------------------
	MOV	ah, 9
	MOV	dx, offset putin
	INT	21h
	
	MOV	ah, 0Ah
	MOV	dx, offset inputmax
	INT	21h	

	MOV	ah, 9
	MOV	dx, offset nextline
	INT	21h
    
	;------------------------------------------------------------------------
	;Apdorojami ivesti duomenis
	;------------------------------------------------------------------------
	MOV	cl, quantity		      ;i al idedama kiek simboliu buvo nuskaityta
	MOV	bx, offset input	      ;i bx idedamas pirmojo nuskaityto simbolio adresas
	
	;------------------------------------------------------------------------
	;Apsauga nuo tusciu eiluciu
	;------------------------------------------------------------------------
	CMP cl, 0                     ;jei neivesta neivieno simbolio
	JNE @main 
	
	MOV	ah, 9
	MOV	dx, offset empty
	INT	21h			              ;atspausdiname atitinkama klaidos pranesima
	
	JMP @close                    ;ir pereiname prie pabaigos
	
	;------------------------------------------------------------------------
	;Algoritmas
	;------------------------------------------------------------------------
	@main:
	PUSH cx
	XOR ax, ax
	XOR dx, dx
	
	@myloop:
	MOV ch, UpperA                 ;istraukiama 'A' reiksme
	CMP	[ds:bx], ch                ;jei einamasis simbolis mazesnis uz 'A'
	JB	@next    	               ;tai tikrai ne didzioji raide
	MOV ch, UpperZ                 ;istraukiama 'Z' reiksme
	CMP	[ds:bx], ch		           ;jei einamasis simbolis didesnis uz 'Z'
	JA  @iflowercase		       ;tai tikrai ne didzioji raide, bet gali buti ir mazoji, tikriname
	ADD	byte ptr [ds:bx], 20h      ;priesingu atveju keiciame didziaja raide i mazaja
	INC al                         ;skaiciuojamas pakeitimu skaicius
	JMP @next                      ;pereiname prie next

    @iflowercase:
	MOV ch, LowerA                 ;istraukiama 'a' reiksme
	CMP	[ds:bx], ch                ;jei einamasis simbolis mazesnis uz 'a'
	JB	@next		               ;tai ne mazoji raide
	MOV ch, LowerZ                 ;istraukiama 'z' reiksme
	CMP	[ds:bx], ch	               ;jei einamasis simbolis didesnis uz 'z'
	JA  @next		               ;tai ne mazoji raide
	SUB	byte ptr [ds:bx], 20h	   ;priesingu atveju keiciame mazaja raide i didziaja
	INC dl                         ;skaiciuojamas pakeitimu skaicius
	
    @next:
	INC	bx			               ;pereiname prie kito simbolio
	DEC	cl			               ;sumaziname likusiu simboliu skaiciu
	CMP	cl, 0			           ;jei dar liko simboliu
	JNE	@myloop			           ;einam i myloop

	MOV byte ptr [ds:bx], '$'	   ;eilutes gale irasome '$'
	
	PUSH ax
	PUSH dx

	;------------------------------------------------------------------------
	;Isvedamas rezultatas
	;------------------------------------------------------------------------
	MOV	ah, 9
	MOV	dx, offset putout
	INT	21h

	MOV	ah, 9
	MOV	dx, offset input
	INT	21h
	
	MOV	ah, 9
	MOV	dx, offset nextline
	INT	21h
	
	;------------------------------------------------------------------------
	;Isvedamas didziuju ir mazuju raidziu skaicius
	;------------------------------------------------------------------------	
	
	MOV	ah, 9
	MOV	dx, offset gotupper
	INT	21h
	
	POP ax
    CALL NUMPRINT

	MOV	ah, 9
	MOV	dx, offset nextline
	INT	21h
	
	;------------------------------------------------------------------------
	
	MOV	ah, 9
	MOV	dx, offset gotlower
	INT	21h
	
	POP ax
    CALL NUMPRINT
	
	MOV	ah, 9
	MOV	dx, offset nextline
	INT	21h

	;------------------------------------------------------------------------
	;Isvedamas eilutes ilgis
	;------------------------------------------------------------------------
	
	MOV	ah, 9
	MOV	dx, offset stlength
	INT	21h
	
	
	POP ax
    CALL NUMPRINT

	
	;------------------------------------------------------------------------
	;Programos darbo pabaiga
	;------------------------------------------------------------------------
	@close:
	MOV	ax, 4C00h			
	INT	21h	
	
;=======================================================================================
;Procedura, atspausdinanti desimtaini skaiciu
;=======================================================================================
  PROC NUMPRINT

	;------------------------------------------------------------------------
	;Issaugomos registru reiksmes, atribojame ja
	;------------------------------------------------------------------------  
	PUSH	ax
	PUSH    bx
	PUSH	cx
	PUSH	dx
	PUSH	"$$"    ;skirtukas
	
	;------------------------------------------------------------------------
	;Sesioliktainis skaicius konvertuojamas i desimtaini
	;------------------------------------------------------------------------
	MOV	cx, 10

  @convert:
	XOR	dx, dx
	DIV	cx
	PUSH dx
	CMP	ax, 0		;jei dar liko skaitmenu
	JA	@convert	;konvertuojama toliau

	
	;------------------------------------------------------------------------
	;Spausdinamos liekanos, pradedant nuo pabaigos
	;------------------------------------------------------------------------
	MOV	ah, 2
  @print:
	POP	dx
	CMP	dx, "$$"	;jei rastas skirtukas
	JE	@exit		;darbas baigiamas
	ADD	dl, 30h
	INT	21h
	JMP	@print

  @exit:
	;------------------------------------------------------------------------
	;Grazinamos registru reiksmes, iseinama is proceduros
	;------------------------------------------------------------------------
	POP	dx
	POP	cx
	POP bx
	POP	ax
	RET
	NUMPRINT ENDP
	
;=======================================================================================	
END Strt